//+------------------------------------------------------------------+
//|                                                s-WithoutLoss.mq4 |
//|                                          Copyright  2008, Talex |
//|                                      talex.kaliningrad@gmail.com |
//|                  |
//| WithoutLoss             |
//| Pips .
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Talex"
#property link      "talex.kaliningrad@gmail.com"

#define slippage 3

#property show_inputs
extern int WithoutLoss=15;       //      
extern int Pips=1;               //    +   
extern int Pause=5;              //     ,  ,     
extern bool WorkEver=true;       // true -   ,      
extern bool AllSymbols=true;     // true -    , false -     
extern bool AllMagic=true;       // true -    , false -   .

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start() {
   int i,cnt=0,err=0,_digit;
   double sl,_point;
   string txt="";
   bool flag=true;
   datetime ot;
//--------------------------------------------------------------------

   while(!IsStopped()&&flag) {
      cnt=OrdersTotal()-1;
      for(i=cnt;i>=0;i--) {
         txt="  s-WithoutLoss\n";
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))continue;
//   
         if((WithoutLoss-Pips)<MarketInfo(OrderSymbol(),MODE_STOPLEVEL)) {
            Alert(" : ",OrderSymbol(),"    / : ",MarketInfo(OrderSymbol(),MODE_STOPLEVEL));
            continue;
         }
         if((OrderType()!=OP_BUY)&&(OrderType()!=OP_SELL)) continue;
         if(!AllSymbols)
            if(OrderSymbol()!=Symbol()) continue; 
         if(!AllMagic)
            if(OrderMagicNumber()!=0) continue; 
         Comment(txt);
         RefreshRates();
         if(OrderProfit()>=(WithoutLoss*MarketInfo(OrderSymbol(),MODE_TICKVALUE)*OrderLots())) {
            _digit=MarketInfo(OrderSymbol(),MODE_DIGITS);
            _point=MarketInfo(OrderSymbol(),MODE_POINT);
            if(OrderType()==OP_BUY) {
               sl=NormalizeDouble((OrderOpenPrice()+Pips*_point),_digit);
               if(NormalizeDouble(OrderStopLoss(),_digit)>= NormalizeDouble(sl,_digit)) continue;
            }
            if(OrderType()==OP_SELL) {
               sl=NormalizeDouble((OrderOpenPrice()-Pips*_point),_digit);
               if((NormalizeDouble(OrderStopLoss(),_digit)<= NormalizeDouble(sl,_digit))&&(OrderStopLoss()!=0.0)) continue;
            }
            txt=txt + "   : "+OrderSymbol();
            Comment(txt);
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE)) {
               err=GetLastError();
               Print("    ", OrderTicket(), " : ",err);
            }
         }
      }
      Sleep(Pause*1000);
      if(WorkEver) flag=true;
         else {
            flag=false;
            for(i=cnt;i>=0;i--) {
               if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))continue;
                  if(OrderType()==OP_BUY) {
                  if((OrderStopLoss()==0)||(OrderStopLoss()<OrderOpenPrice())) flag=true;
               }
               if(OrderType()==OP_SELL) {
                  if((OrderStopLoss()==0)||(OrderStopLoss()>OrderOpenPrice())) flag=true;
               }
            }
         }
   }
   Comment("");
   return;
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
   Comment("");
   return;
}
//+------------------------------------------------------------------+